/***************************************************************************
                                  ksattrbtn.h
                             -------------------
    begin                : Fri Jan 7 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildbk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSATTRIBBUTTON_H
#define KSATTRIBBUTTON_H

#include <qwidget.h>
#include <klocale.h>
#include <qpushbutton.h>
#include <qguardedptr.h>
#include "../widgets/qsgattr.h"

class KSAttrPanel;

/**
  *@author Kamil Dobkowski
  */

class KSAttrBtn : public QPushButton
 {
   Q_OBJECT

   public:

      KSAttrBtn(QWidget *parent=0, const char *name=0);
     ~KSAttrBtn();

   signals:

   	void attrChanged();
   	
   protected slots:

       virtual void showAttrPanel() {}
       virtual void acceptValue() {}

   protected:

        void setAttrPanel( KSAttrPanel *panel );
        QGuardedPtr<KSAttrPanel> apanel;
 };

//-----------------------------------------------------------//

class KSFillBtn : public KSAttrBtn
 {
   Q_OBJECT

   public:

        KSFillBtn( QWidget *parent=0, const char *name=0);
       ~KSFillBtn();

        void setDialogFill( const QSGFill &f );
        QSGFill dialogFill() const { return f; }

   protected:

       void drawButtonLabel ( QPainter * p );
       QSGFill f;

   protected slots:

       virtual void showAttrPanel();
       virtual void acceptValue();

 };

//-----------------------------------------------------------//

class KSFontBtn : public KSAttrBtn
 {
   Q_OBJECT

   public:

        KSFontBtn( QWidget *parent=0, const char *name=0);
       ~KSFontBtn();

        void setDialogFont( const QSGFont &f );
        QSGFont dialogFont() const { return f; }

   protected:

        void drawButtonLabel ( QPainter * p );
        QSGFont f;

  protected slots:

       virtual void showAttrPanel();
       virtual void acceptValue();
 };

//-----------------------------------------------------------//

class KSLineBtn : public KSAttrBtn
 {
   Q_OBJECT

   public:

        KSLineBtn( QWidget *parent=0, const char *name=0);
       ~KSLineBtn();

        void setDialogLine( const QSGLine &l );
        QSGLine dialogLine() const { return l; }

   protected:

        void drawButtonLabel ( QPainter * p );
        QSGLine l;

  protected slots:

       virtual void showAttrPanel();
       virtual void acceptValue();
 };

//-----------------------------------------------------------//

class KSPointBtn : public KSAttrBtn
 {
  Q_OBJECT

  public:

        KSPointBtn(QWidget *parent=0, const char *name=0);
        ~KSPointBtn();

        void setDialogPoint( const QSGPoint &p );
        QSGPoint dialogPoint() const { return p; }

   protected:

        void drawButtonLabel( QPainter *p );
        QSGPoint p;

   protected slots:

       virtual void showAttrPanel();
       virtual void acceptValue();

  };

//-----------------------------------------------------------//

class KSArrowBtn : public KSAttrBtn
 {
  Q_OBJECT

  public:
        KSArrowBtn(QWidget *parent=0, bool end1=false, const char *name=0);
        ~KSArrowBtn();
        void setDialogArrow( const QSGArrow &a );
        QSGArrow dialogArrow() const { return a; }

   protected:

        void drawButtonLabel( QPainter *p );
        QSGArrow a;
        bool end1;

   protected slots:

       virtual void showAttrPanel();
       virtual void acceptValue();

  };
#endif
