/***************************************************************************
                                  ksattrpanel.cpp
                             -------------------
    begin                : Tue Oct 10 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksattrpanel.h"
#include "kscolorpanel.h"
#include <qpushbutton.h>

//--------------------------------------------------------------//

KSAttrPanel::KSAttrPanel(QWidget *parent, const char *name )
: QWidget(parent,name)
 {
  presult = false;
  colpanel = new KSColorPanel( this );
  colpanel->move( 0, 180 );
  colpanel->show();
  bok = new QPushButton( i18n("Set"),     this );
  bca = new QPushButton( i18n("Close"), this );
  bok->setGeometry(  5, 5, 55, 20 );
  bca->setGeometry( 65, 5, 55, 20 );
  connect( bok, SIGNAL(clicked()), this, SLOT(ok_clicked()) );
  connect( bca, SIGNAL(clicked()), this, SLOT(cancel_clicked()) );
 }

//--------------------------------------------------------------//

KSAttrPanel::~KSAttrPanel()
 {
 }

//--------------------------------------------------------------//

void KSAttrPanel::setPanelColor( const QSGColor& color )
 {
  colpanel->setPanelColor( color );
 }

//--------------------------------------------------------------//

QSGColor KSAttrPanel::panelColor() const
 {
  return colpanel->panelColor();
 }

//--------------------------------------------------------------//

void KSAttrPanel::ok_clicked()
 {
  presult = true;
  emit acceptValue();
 }

//--------------------------------------------------------------//

void KSAttrPanel::cancel_clicked()
 {
  presult = false;
  emit acceptValue();
 }

