/***************************************************************************
                                  ksattrpanel.h
                             -------------------
    begin                : Tue Oct 10 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSATTRPANEL_H
#define KSATTRPANEL_H

#include <qwidget.h>
#include "../widgets/qsgattr.h"

class QPushButton;
class KSColorPanel;

/**Base class for attr panels.
  *@author Kamil Dobkowski
  */

class KSAttrPanel : public QWidget  {

   Q_OBJECT

  public:

        KSAttrPanel(QWidget *parent=0, const char *name=0);
       ~KSAttrPanel();

        void setPanelColor( const QSGColor& color );
        QSGColor panelColor() const;
        bool result() const { return presult; }

  signals:

        void acceptValue();

  protected:

        bool presult;
        QPushButton *bok;
        QPushButton *bca;
        KSColorPanel *colpanel;

  private slots:

        void ok_clicked();
        void cancel_clicked();
};

#endif
