/***************************************************************************
                                  kscarrowpanel.cpp
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kscarrowpanel.h"
#include "ksattrbtn.h"
#include "../part/kscommands.h"

//-----------------------------------------------------------//

KSPanelButtonCArrow::KSPanelButtonCArrow( QWidget *parent, KSWorkbook *workbook, QSCObject *o )
:KSPanelButton( parent, workbook, BObject, "panel_arrow", tr("arrow") )
 {
  m_object = o;
 }

//-----------------------------------------------------------//

KSPanelButtonCArrow::~KSPanelButtonCArrow()
 {
 }

//-----------------------------------------------------------//

KSPanel *KSPanelButtonCArrow::createPanel( QWidget *panelParent )
 {
  return new KSCArrowPanel( panelParent, m_workbook, m_object );
 }

//-----------------------------------------------------------//
//-----------------------------------------------------------//
//-----------------------------------------------------------//
//-----------------------------------------------------------//
//-----------------------------------------------------------//

KSCArrowPanel::KSCArrowPanel(QWidget *parent, KSWorkbook *workbook, QSCObject *init_o, const char *name)
: KSPanel(parent,name)
 {
	initDialog();
	btn_end1point = new KSPointBtn( this ); btn_end1point->setGeometry( point1p->geometry() );
  	btn_end2point = new KSPointBtn( this ); btn_end2point->setGeometry( point2p->geometry() );
  	btn_line      = new KSLineBtn(  this ); btn_line->setGeometry( linep->geometry() );
  	btn_end1arrow = new KSArrowBtn( this, true  ); btn_end1arrow->setGeometry( arrow1p->geometry() );
	btn_end2arrow = new KSArrowBtn( this, false ); btn_end2arrow->setGeometry( arrow2p->geometry() );
    
    m_workbook = workbook;
    o = init_o;

    watchProperties();
 }

//-------------------------------------------------------------//

KSCArrowPanel::~KSCArrowPanel()
 {
 }

//-------------------------------------------------------------//

void KSCArrowPanel::readProperties()
 {
  btn_end1point->setDialogPoint( toQSGPoint(o->property("originPoint").toString()) );
  btn_end2point->setDialogPoint( toQSGPoint(o->property("endPoint").toString()) );
  btn_end1arrow->setDialogArrow( toQSGArrow(o->property("originArrow").toString()) );
  btn_end2arrow->setDialogArrow( toQSGArrow(o->property("endArrow").toString()) );
  btn_line->setDialogLine( toQSGLine(o->property("line").toString()) );
 }
/*
  btn_end1point->setDialogPoint( *end1point );
  btn_end2point->setDialogPoint( *end2point );
  btn_end1arrow->setDialogArrow( *end1style );
  btn_end2arrow->setDialogArrow( *end2style );
  btn_line->setDialogLine( *line );
*/
//-------------------------------------------------------------//

void KSCArrowPanel::applyProperties()
 {
  KSCmdSetProperties *cmd = new KSCmdSetProperties(o);
  cmd->setProperty( "originPoint", toQString(btn_end1point->dialogPoint()) );
  cmd->setProperty( "endPoint", toQString(btn_end2point->dialogPoint()) );
  cmd->setProperty( "originArrow", toQString(btn_end1arrow->dialogArrow()) );
  cmd->setProperty( "endArrow", toQString(btn_end2arrow->dialogArrow()) );
  cmd->setProperty( "line", toQString(btn_line->dialogLine()) );
  m_workbook->execute( cmd );
 }

/*
  *end1point = btn_end1point->dialogPoint();
  *end2point = btn_end2point->dialogPoint();
  *end1style = btn_end1arrow->dialogArrow();
  *end2style = btn_end2arrow->dialogArrow();
  *line = btn_line->dialogLine();
  o->changed();
*/
