/***************************************************************************
                                  ksclegendcpanel.cpp
                             -------------------
    begin                : Mon Jul 10 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksclegendcpanel.h"
#include "../part/kscommands.h"

//-----------------------------------------------------------//

KSPanelButtonCLegend::KSPanelButtonCLegend( QWidget *parent, KSWorkbook *workbook, QSCObject *o )
:KSPanelButton( parent, workbook, BObject, "panel_legend", tr("Legend") )
 {
  m_object = o;
 }

//-----------------------------------------------------------//

KSPanelButtonCLegend::~KSPanelButtonCLegend()
 {
 }

//-----------------------------------------------------------//

KSPanel *KSPanelButtonCLegend::createPanel( QWidget *panelParent )
 {
  return new KSCLegendCPanel( panelParent, m_workbook, m_object );
 }

//------------------------------------------------------------------//

KSCLegendCPanel::KSCLegendCPanel(QWidget *parent, KSWorkbook *workbook, QSCObject* init_o, const char *name)
: KSPanel(parent,name)
 {
  initDialog();
  o = init_o;
  m_workbook = workbook;
  watchProperties();
 }

//------------------------------------------------------------------//

KSCLegendCPanel::~KSCLegendCPanel()
 {
 }

//------------------------------------------------------------------//

void KSCLegendCPanel::readProperties()
 {
  columns->setValue( o->property("columns").toInt() );
  //columns->setValue( *cols );
 }
 
//------------------------------------------------------------------//

void KSCLegendCPanel::applyProperties()
 {
  KSCmdSetProperties *cmd = new KSCmdSetProperties(o);
  cmd->setProperty("columns",columns->value());
  m_workbook->execute( cmd );
 }

/*
  *cols = columns->value();
  o->changed();
*/

