/***************************************************************************
                                  kscrectpanel.cpp
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kscrectpanel.h"
#include "ksattrbtn.h"
#include "../part/kscommands.h"

//-----------------------------------------------------------//

KSPanelButtonCRect::KSPanelButtonCRect( QWidget *parent, KSWorkbook *workbook, QSCObject *o )
:KSPanelButton( parent, workbook, BObject, "panel_rect", tr("Rectangle/Ellipse") )
 {
  m_object = o;
 }

//-----------------------------------------------------------//

KSPanelButtonCRect::~KSPanelButtonCRect()
 {
 }

//-----------------------------------------------------------//

KSPanel *KSPanelButtonCRect::createPanel( QWidget *panelParent )
 {
  return new KSCRectPanel( panelParent, m_workbook, m_object );
 }

//-------------------------------------------------------------//
//-------------------------------------------------------------//
//-------------------------------------------------------------//
//-------------------------------------------------------------//

KSCRectPanel::KSCRectPanel( QWidget *parent, KSWorkbook *workbook, QSCObject *init_o, const char *name )
: KSPanel(parent,name)
 {
  initDialog();
  pen   = new KSLineBtn( this ); pen->setGeometry( penp->geometry() );
  brush = new KSFillBtn( this ); brush->setGeometry( brushp->geometry() );
  shadowfill = new KSFillBtn( this ); shadowfill->setGeometry( shadowfillp->geometry() );
  o = init_o;
  m_workbook = workbook;
  watchProperties();
}

//-------------------------------------------------------------//

KSCRectPanel::~KSCRectPanel()
 {
 }

//-------------------------------------------------------------//

void KSCRectPanel::readProperties()
 {
  ellipse->setChecked( o->property("ellipse").toBool() );
  pen->setDialogLine( toQSGLine(o->property("frame").toString()) );
  brush->setDialogFill( toQSGFill(o->property("fill").toString()) );
  shadowfill->setDialogFill( toQSGFill(o->property("shadowFill").toString()) );
  shadowdx->setValue( o->property("shadowPosX").toInt() );
  shadowdy->setValue( o->property("shadowPosY").toInt() );
 }

/*
  brush->setDialogFill( *fill );
  shadowfill->setDialogFill( *sfill );
  shadowdx->setValue( spos->x );
  shadowdy->setValue( spos->y );
*/

//-------------------------------------------------------------//

void KSCRectPanel::applyProperties()
 {
  KSCmdSetProperties *cmd = new KSCmdSetProperties(o);
  cmd->setProperty( "ellipse", ellipse->isChecked() );
  cmd->setProperty( "frame", toQString(pen->dialogLine()) );
  cmd->setProperty( "fill", toQString(brush->dialogFill()) );
  cmd->setProperty( "shadowFill", toQString(shadowfill->dialogFill()) );
  cmd->setProperty( "shadowPosX", shadowdx->value() );
  cmd->setProperty( "shadowPosY", shadowdy->value() );
  m_workbook->execute( cmd );
 }

/*
  *e = ellipse->isChecked();
  *line = pen->dialogLine();
  *fill = brush->dialogFill();
  *sfill = shadowfill->dialogFill();
  spos->x = shadowdx->value();
  spos->y = shadowdy->value();

  o->changed();
*/


