/***************************************************************************
                                 ksframepanel.cpp
                             -------------------
    begin                : Mon Jan 10 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildbk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksframepanel.h"
#include "../widgets/qsaxes2d.h"
#include "../part/kscommands.h"
#include "ksattrbtn.h"
#include <qwhatsthis.h>

//-----------------------------------------------------------//

KSPanelButtonFrame::KSPanelButtonFrame( QWidget *parent, KSWorkbook *workbook, QSAxes2D *axes )
:KSPanelButton( parent, workbook, BGeneral, "panel_frame", tr("Frame") )
 {
  m_axes = axes;
 }

//-----------------------------------------------------------//

KSPanelButtonFrame::~KSPanelButtonFrame()
 {
 }

//-----------------------------------------------------------//

KSPanel *KSPanelButtonFrame::createPanel( QWidget *panelParent )
 {
  return new KSFramePanel( panelParent, m_workbook, m_axes );
 }

//-----------------------------------------------------------//

bool KSPanelButtonFrame::isButtonFor( QSCObject *object, int category, int element )
 {
  if ( category == QSAxes::GeneralCategory &&
       object->isAxesShadow() &&
       element == 0 ) return true;
  return false;
 }

//-------------------------------------------------------------//
//-------------------------------------------------------------//
//-------------------------------------------------------------//
//-------------------------------------------------------------//

KSFramePanel::KSFramePanel(QWidget *parent, KSWorkbook *workbook, QSAxes2D *plot, const char *name)
: KSPanel(parent,name)
 {
  assert( plot ); p2 = plot;
  m_workbook = workbook;

  initDialog();
  pcol = new KSFillBtn( this ); pcol->setGeometry( pcolw->geometry() );
  fcol = new KSFillBtn( this ); fcol->setGeometry( fcolw->geometry() );

  QWhatsThis::add( pcol,   i18n("Plot area fill\n\nFill style of the inside-frame area") );
  QWhatsThis::add( fcol,   i18n("Frame fill\n\nFill style of the plot frame") );
  QWhatsThis::add( thicks, i18n("Frame thickness\n\nThickness of the plot frame.")  );

  watchProperties();
 }

//-------------------------------------------------------------//

KSFramePanel::~KSFramePanel()
 {
 }

//-------------------------------------------------------------//

void KSFramePanel::readProperties()
 {
  thicks->setValue( p2->frameWidth() );
  pcol->setDialogFill( p2->fill( QSAxes2D::RectFill)  );
  fcol->setDialogFill( p2->fill( QSAxes2D::FrameFill) );
 }

//-------------------------------------------------------------//

void KSFramePanel::applyProperties()
 {
  KSCmdSetGraphicalProperties *cmd = new KSCmdSetGraphicalProperties(p2);
  cmd->setProperty( "frameWidth", thicks->value() );
  cmd->setFill( QSAxes2D::RectFill,  pcol->dialogFill() );
  cmd->setFill( QSAxes2D::FrameFill, fcol->dialogFill() );
  m_workbook->execute( cmd );
 }

/*
   p2->setFrameWidth( thicks->value() );
  p2->setFill( QSAxes2D::RectFill,  pcol->dialogFill() );
  p2->setFill( QSAxes2D::FrameFill, fcol->dialogFill() );
*/
