/***************************************************************************
                                 ksgeneralpanel.cpp
                             -------------------
    begin                : Mon Jan 10 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildbk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksgeneralpanel.h"
#include "ksattrbtn.h"
#include "../widgets/qsaxes.h"
#include "../part/kscommands.h"
#include <qpainter.h>
#include <qwhatsthis.h>

//-----------------------------------------------------------//

KSPanelButtonGeneral::KSPanelButtonGeneral( QWidget *parent, KSWorkbook *workbook, QSAxes *axes )
:KSPanelButton( parent, workbook, BGeneral, "panel_general", tr("Position/Title") )
 {
  m_axes = axes;
 }

//-----------------------------------------------------------//

KSPanelButtonGeneral::~KSPanelButtonGeneral()
 {
 }

//-----------------------------------------------------------//

KSPanel *KSPanelButtonGeneral::createPanel( QWidget *panelParent )
 {
  return new KSGeneralPanel( panelParent, m_workbook, m_axes );
 }

//-----------------------------------------------------------//

bool KSPanelButtonGeneral::isButtonFor( QSCObject *, int, int )
 {
//  if ( category == QSAxes::GeneralCategory &&
//       object->isAxesShadow() &&
//       element == 0 ) return true;
  return false;
 }

//-------------------------------------------------------------//
//-------------------------------------------------------------//
//-------------------------------------------------------------//
//-------------------------------------------------------------//

KSGeneralPanel::KSGeneralPanel(QWidget *parent, KSWorkbook *workbook, QSAxes *plot, const char *name)
: KSPanel(parent,name)
 {
  assert( plot ); p = plot;
  m_workbook = workbook;
  initDialog();
  bcol = new KSFillBtn( this ); bcol->setGeometry( bcolw->geometry() );
  //font = new KSFontBtn( this ); font->setGeometry( fontw->geometry() );
  QWhatsThis::add( titlee, i18n("Plot title\n\nYou can write a title text here.") );
  //QWhatsThis::add( font, i18n("Title font\n\nFont used to draw a title."));
  //QWhatsThis::add( tposc, i18n("Title position\n\nPostion of the plot title on the canvas.") );
  QWhatsThis::add( bcol, i18n("Background fill\n\n Background fill style.") );
  watchProperties();
 }

//-------------------------------------------------------------//

KSGeneralPanel::~KSGeneralPanel()
 {
 }

//-------------------------------------------------------------//

void KSGeneralPanel::readProperties()
 {
  bcol->setDialogFill( p->background() );
  titlee->setText( p->title() );
  xpose->setText( QString::number(p->posMM().x) );
  ypose->setText( QString::number(p->posMM().y) );
  widthe->setText( QString::number(p->sizeMM().x) );
  heighte->setText( QString::number(p->sizeMM().y) );
  draw_in_background->setChecked( p->drawInBackground() );
 }

//-------------------------------------------------------------//

void KSGeneralPanel::applyProperties()
 {
  KSCmdSetGraphicalProperties *cmd = new KSCmdSetGraphicalProperties(p);
  cmd->setProperty( "background", toQString(bcol->dialogFill()) );
  cmd->setProperty( "title", titlee->text() );
  cmd->setProperty( "xPosMM", xpose->text().toDouble() );
  cmd->setProperty( "yPosMM", ypose->text().toDouble() );
  cmd->setProperty( "widthMM", widthe->text().toDouble() );
  cmd->setProperty( "heightMM", heighte->text().toDouble() );
  cmd->setProperty( "drawInBackground", draw_in_background->isChecked() );
  m_workbook->execute( cmd );

 }

/*
 // p->setTitleFont( font->dialogFont() );
  p->setBackground( bcol->dialogFill() );
  p->setTitle( titlee->text() );
  //p->setTitlePos( tposc->currentItem() ? QSAxes::TitleBottom : QSAxes::TitleTop );
  p->setPosMM( QSPt2f(xpose->text().toDouble(),
  		     ypose->text().toDouble()) );
  p->setSizeMM( QSPt2f(widthe->text().toDouble(),
  		      heighte->text().toDouble()) );
  p->setDrawInBackground( draw_in_background->isChecked() );
*/

