/***************************************************************************
                          ksrangepanel.h  -  description
                             -------------------
    begin                : Sun Sep 2 2001
    copyright            : (C) 2001 by Kamil Dobkowski
    email                : kamildobk@poczta.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSRANGEPANEL_H
#define KSRANGEPANEL_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
//Generated area. DO NOT EDIT!!!(end)

#include <klocale.h>
#include "kspanel.h"
#include "../widgets/qsaxes.h"

//------------------------------------------------------------------------------------------------------//

class KSPanelButtonRange : public KSPanelButton {
 Q_OBJECT
  public:
     KSPanelButtonRange( QWidget *parent, KSWorkbook *workbook, QSAxes *axes );
     virtual ~KSPanelButtonRange();
     virtual KSPanel *createPanel( QWidget *panelParent );
     virtual bool isButtonFor( QSCObject *object, int category, int element );
  private:
     QSAxes *m_axes;
  };

//------------------------------------------------------------------------------------------------------//

class QSAxes3D;


class KSRangePanel : public KSPanel  {
   Q_OBJECT
public: 
	KSRangePanel(QWidget *parent, KSWorkbook *workbook, QSAxes *axes, const char *name=0);
	~KSRangePanel();
	virtual void readProperties();
	virtual void applyProperties();
protected: 
	void initDialog();
	//Generated area. DO NOT EDIT!!!(begin)
	QPushButton *viewLeft;
	QPushButton *viewUp;
	QPushButton *viewDown;
	QPushButton *viewRight;
	QPushButton *xPlus;
	QPushButton *yPlus;
	QPushButton *xMinus;
	QPushButton *yMinus;
	QPushButton *zPlus;
	QPushButton *vPlus;
	QPushButton *zMinus;
	QPushButton *vMinus;
	QLabel *QLabel_4;
	QLabel *QLabel_2;
	QLabel *QLabel_3;
	QPushButton *rememberView;
	QPushButton *view1;
	QPushButton *view2;
	QPushButton *view3;
	//Generated area. DO NOT EDIT!!!(end)

private:
	QSAxes *m_axes;
        QSAxes3D *m_axes3;
	KSWorkbook *m_workbook;
	void shift_range( int axis_type, double shift );

private slots:
	void x_plus();
	void y_plus();
	void z_plus();
	void v_plus();

	void x_minus();
	void y_minus();
	void z_minus();
	void v_minus();

	void view_up();
	void view_down();
	void view_left();
	void view_right();

        void set_view_1();
        void set_view_2();
        void set_view_3();
        void remember_view();
};

#endif
