/***************************************************************************
                                  kmatplotshell.h
                             -------------------
    begin                : Sat Mar 11 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMATPLOTSHELL_H
#define KMATPLOTSHELL_H

#include <kparts/mainwindow.h>
#include <kparts/part.h>

class KToggleAction;
class KRecentFilesAction;
class QSPlotView;
class KSWorkbook;

/**
  *@author Kamil Dobkowski
  */
class KMatplotShell : public KParts::MainWindow  {
   Q_OBJECT
public:
   KMatplotShell( const char *name=0);
  ~KMatplotShell();
   QString nativeFormatPattern() const;
   QString nativeFormatName() const;

public slots:
    bool openURL( const KURL& url );
    bool mergeURL( const KURL& url );
    bool saveURL( const KURL& url );
    void slotFileOpen();
    void slotFileMerge();
    void slotFileSave();
    void slotFileSaveAs();
    void slotExportPicture();
    void slotDatasets();
    void slotObjects();
    void slotWorksheet();
    void slotViewInfo();
    void slotConfAccels();
    void toggleToolBar();
    void toggleStatusBar();

protected slots:
    void slotEditToolbars();
    void slot_curr_page_changed();
    void slot_active_axes_changed();

protected:
   KAction *m_datasets;
   KAction *m_objects;
   KToggleAction *m_show_toolbar;
   KToggleAction *m_show_statusbar;
   KRecentFilesAction *m_recent_files;
   KParts::ReadWritePart* m_kmatplot_part;

   QSPlotView *view();
   KSWorkbook *workbook();
   virtual void readProperties( KConfig* config );
   virtual void saveProperties( KConfig* config );
   void readOptions();
   void saveOptions();
   virtual bool queryExit();
};

#endif
