/***************************************************************************
                                 ksexception.h                               
                             -------------------                                         
    begin                : 01-January-2000
    copyright            : (C) 2000 by Kamil Dobkowski                         
    email                : kamildobk@poczta.onet.pl                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef KSEXCEPTION_H
#define KSEXCEPTION_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include<qstring.h>
#include <klocale.h>

/**
  * Standard exception.
  * @author Kamil Dobkowski
  * @version 0.0.1
  */
class KSException {

      public:

        /**
          * Common exception types.
          */
        enum StandardException{ IOError          = 0,
                                FileError        = 1,
                                NullArgument     = 2,
                                BadArgument      = 3,
                                MemoryAllocation = 4,
                                NotImplemented   = 5,
                                DataCorrupted    = 6,
                                SearchFailed     = 7,
                                Cancelled        = 8,
                                Unknown          = 9 };

        /**
          * Constructor. Error message is an argument.
          */
        KSException( QString message ): id(Unknown), msg(message) {}

        /**
          * Constructor. Exception type is an argument.
          */
        KSException( StandardException e ): id(e), msg(standard_msg[e]) {}

        /**
          * Destructor.
          */
       ~KSException() {}

        /**
          * Exception id.
          */
        StandardException id;

        /**
          * Error message.
          */
        QString msg;

        private:

         static const char *standard_msg[];

     };

#endif

























