/***************************************************************************
                                  kmatplotfactory.cpp
                             -------------------
    begin                : Sat Mar 11 2000
    copyright            : (C) 2000 by Kamil Dobkowski
    email                : kamildobk@friko.onet.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmatplotfactory.h"
#include "kmatplotpart.h"
//#include "resource.h"
#include <klocale.h>
#include <kinstance.h>
#include <kaboutdata.h>
#include <kdebug.h>

KInstance* KMatplotFactory::s_global = 0;

///////////////////////////////////////////////////////
//                                                   //
//                     Entry point                   //
//                                                   //
///////////////////////////////////////////////////////

extern "C"
{
    void* init_libkmatplot()
    {
        return new KMatplotFactory;
    }
};

///////////////////////////////////////////////////////



KMatplotFactory::KMatplotFactory( QObject *parent, const char *name )
: KLibFactory( parent,name )
 {
 }

//-------------------------------------------------------------//

KMatplotFactory::~KMatplotFactory()
{
  if ( s_global ) {
    delete s_global;
    s_global = NULL;
    }
}

//-------------------------------------------------------------//

QObject* KMatplotFactory::create( QObject* parent, const char* name, const char *classname, const QStringList & )
{
 if ( parent && !parent->inherits("QWidget") ) {
    kdError() << "KMatplotPart: parent must inherit QWidget!" << endl;
    return NULL;
    }

 KMatplotPart *part = new KMatplotPart( (QWidget *)parent, name );
     
 if ( QCString(classname) == "KParts::ReadOnlyPart" ) {
    part->setReadWrite( false );
    }
 else 
 if ( QCString(classname) != "KParts::ReadWritePart" ) {
    delete part;
    kdError() << "KMatplotFactory: Classname must be KParts::ReadWritePart or KParts::ReadOnlyPart !" << endl;
    return NULL;
    }
 
 emit objectCreated(part);
 return part;
}

//-------------------------------------------------------------//

KInstance* KMatplotFactory::global()
{
 if ( !s_global ) {
    KAboutData *about = new KAboutData("kmatplot",
					I18N_NOOP("KMatplot"),
        				"0.1",
					I18N_NOOP("Mathematical function plotter."),
					KAboutData::License_GPL,
        				"(c) 2000 Kamil Dobkowski" );
    about->addAuthor("Kamil Dobkowski", 
		     0, 
		     "kamildobk@poczta.onet.pl" );
    s_global = new KInstance(about);
    }

 return s_global;
}

