/***************************************************************************
                          ksdataobjectfactory.cpp  -  description
                             -------------------
    begin                : Thu Dec 6 2001
    copyright            : (C) 2001 by kamil
    email                : kamil@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksdataobjectfactory.h"
#include "../widgets/qsdata.h"
#include "../widgets/qssurface.h"
#include "../widgets/qscontour.h"
#include "../widgets/qsimage.h"
#include "ksmatrix.h"

//-------------------------------------------------------------------------//

KSDataObjectFactory::KSDataObjectFactory()
 {
 }

//-------------------------------------------------------------------------//

KSDataObjectFactory::~KSDataObjectFactory()
 {
 }

//-------------------------------------------------------------------------//

MPSymbol *KSDataObjectFactory::channelVariable( QSData *object, const char *identifier, MPSymbolList *args, int columnFrom, int columnTo )
 {
  // ups, ugly hack ! - do not return x and y as a vector but rather make grid from them
  if ( dynamic_cast<QSImage*>(object) ) {
	QSImage *plot = dynamic_cast<QSImage*>(object);
	int rows = plot->matrix(QSImage::YVector) ? plot->matrix(QSImage::YVector)->rows()-1 : 0;
	int cols = plot->matrix(QSImage::XVector) ? plot->matrix(QSImage::XVector)->cols()-1 : 0;
	if ( plot->channelVariable( QSImage::XVector ) == identifier && object->matrix(QSImage::XVector) )
		return new MPSymQSMatrix( object->matrix(QSImage::XVector), QRect(0,0,cols,rows), args, columnFrom, columnTo, identifier );
	if ( plot->channelVariable( QSImage::YVector ) == identifier && object->matrix(QSImage::YVector) )
		return new MPSymQSMatrix( object->matrix(QSImage::YVector), QRect(0,0,cols,rows), args, columnFrom, columnTo, identifier );	
	}
  if ( dynamic_cast<QSGriddedContour*>(object) ) {
	QSGriddedContour *plot = dynamic_cast<QSGriddedContour*>(object);
	int rows = plot->matrix(QSGriddedContour::YVector) ? plot->matrix(QSGriddedContour::YVector)->rows() : 0;
	int cols = plot->matrix(QSGriddedContour::XVector) ? plot->matrix(QSGriddedContour::XVector)->cols() : 0;
	if ( plot->channelVariable( QSGriddedContour::XVector ) == identifier && object->matrix(QSGriddedContour::XVector) )
		return new MPSymQSMatrix( object->matrix(QSGriddedContour::XVector), QRect(0,0,cols,rows), args, columnFrom, columnTo, identifier );
	if ( plot->channelVariable( QSGriddedContour::YVector ) == identifier && object->matrix(QSGriddedContour::YVector) )
		return new MPSymQSMatrix( object->matrix(QSGriddedContour::YVector), QRect(0,0,cols,rows), args, columnFrom, columnTo, identifier );
	}
  if ( dynamic_cast<QSSurface*>(object) ) {
	QSSurface *plot = dynamic_cast<QSSurface*>(object);
	int rows = plot->matrix(QSSurface::YVector) ? plot->matrix(QSSurface::YVector)->rows() : 0;
	int cols = plot->matrix(QSSurface::XVector) ? plot->matrix(QSSurface::XVector)->cols() : 0;
	if ( plot->channelVariable( QSSurface::XVector ) == identifier && object->matrix(QSSurface::XVector) )
		return new MPSymQSMatrix( object->matrix(QSSurface::XVector), QRect(0,0,cols,rows), args, columnFrom, columnTo, identifier );
	if ( plot->channelVariable( QSSurface::YVector ) == identifier && object->matrix(QSSurface::YVector) )
		return new MPSymQSMatrix( object->matrix(QSSurface::YVector), QRect(0,0,cols,rows), args, columnFrom, columnTo, identifier );
	}
  for( int i=0; i<object->channelCount(); i++ ) {
	if ( object->channelVariable(i) == identifier &&
		object->matrix(i) &&
		object->matrix(i)->rows() &&
		object->matrix(i)->cols()  ) {
		 MPSymbol *sym = new MPSymQSMatrix( object->matrix(i), args, columnFrom, columnTo, identifier );
		 return sym;		
		 }
	}
	
  return NULL;
 }


//-------------------------------------------------------------------------//




