/***************************************************************************
                          ksdataobjectfactory.h  -  description
                             -------------------
    begin                : Thu Dec 6 2001
    copyright            : (C) 2001 by kamil
    email                : kamil@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSDATAOBJECTFACTORY_H
#define KSDATAOBJECTFACTORY_H

// POLACZ Z KSPLOTCHANNELS !
class QSData;
class MPSymbol;
class MPSymbolList;

/**
  * This is the class which provides some metadata information
  * about QSData objects. Many of the methods should be really
  * virtual functions of the QSData objects.
  * @author kamil
  */
class KSDataObjectFactory {
public:
	/**
	  * Constructor
	  */
	KSDataObjectFactory();
	/**
	  * Destructor
	  */
	virtual ~KSDataObjectFactory();
	/**
	  * Returns channels as a variable 'x', 'y', 'z', 'v', 'dx', 'dy' ... etc
	  * For use in formulas.
	  */
	static MPSymbol *channelVariable( QSData *object, const char *identifier, MPSymbolList *args, int columnFrom, int columnTo );
};

#endif
